# TARGET = intel | nvidia | amd
TARGET=nvidia

ifeq ($(TARGET),nvidia)
  # ARCH = V100 | A100
  ARCH=V100
  CXX = clang++ -fsycl -fsycl-targets=nvptx64-nvidia-cuda
  ifeq ($(ARCH),A100)
    CXX += -Xsycl-target-backend '--cuda-gpu-arch=sm_80'
  else
    CXX += -Xsycl-target-backend '--cuda-gpu-arch=sm_70'
  endif
  CXX += -Wno-unknown-cuda-version
else ifeq ($(TARGET),intel)
  CXX = dpcpp
  LDFLAGS = -lOpenCL
else ifeq ($(TARGET),amd)
  # ARCH = MI100 | MI50
  ARCH = MI100
  CXX = clang++ -fsycl -fsycl-targets=amdgcn-amd-amdhsa
  ifeq ($(ARCH),MI100)
    CXX += -Xsycl-target-backend '--offload-arch=gfx908'
  else ifeq ($(ARCH),MI50)
    CXX += -Xsycl-target-backend '--offload-arch=gfx906'
  else 
    echo "Unknown AMD Architecture"
  endif
else
  echo "Unknown TARGET"
endif

CFLAGS = -O3 -ffast-math -DITERATIONS=100 

SRC     = reduction-usm-02.cpp
EXE     = reduction-usm-02.x

${EXE}: ${SRC} Makefile.usm-02
	${CXX} ${CFLAGS} ${SRC} ${LDFLAGS} ${LIBS} -o $@

clean:
	/bin/rm -f *reduction-usm-02.o *reduction-usm-02.x
